variables:
  SHELLS_UNDER_TEST:
    description: 'All shells we know how to test with.'
    value: >
        bash
        busybox
        dash
        ksh93
        #loksh
        #oksh
        mksh
        posh
        #nsh
        #mrsh
        #yash
        #zsh

.POSIX-test:
  needs: []
  image: $BASE_DOCKER_IMAGE
  before_script:
  - |
    cat <<'EOScript' >arrange_sh.sh
    set -e
    p=$SHELL_UNDER_TEST
    exit_code=0
    case $BASE_DOCKER_IMAGE in
    'alpine:'*)
        apk add --no-cache "$p" || exit_code=$?;;
    'debian:'*)
        case $SHELL_UNDER_TEST in
        busybox)
            p=busybox-static;;
        ksh93)
            p=ksh93u+m;;
        esac
        apt-get -y update
        apt-get install -y "$p" || exit_code=$?;;
    esac
    if [ $exit_code -ne 0 ]; then
        echo not ok - $SHELL_UNDER_TEST '# SKIP' \
         $p not installable in $BASE_DOCKER_IMAGE
        exit 66
    fi
    f=$SHELL_UNDER_TEST
    case $BASE_DOCKER_IMAGE in
    'alpine:'*)
        case $SHELL_UNDER_TEST in
        dash|mrsh|nsh|yash)
            f=/usr/bin/$SHELL_UNDER_TEST;;
        loksh)
            f=/bin/ksh;;
        *)
            f=/bin/$SHELL_UNDER_TEST;;
        esac;;
    'debian:'*)
        case $SHELL_UNDER_TEST in
        yash|posh)
            f=/usr/bin/$SHELL_UNDER_TEST;;
        *)
            f=/bin/$SHELL_UNDER_TEST;;
        esac;;
    esac
    echo "Using $f for /bin/sh..."
    test -x "$f"
    ln -sfn "$f" /bin/sh
    EOScript
  after_script:
  - |
    if [ $CI_JOB_STATUS != 'success' ]; then
      >&2 echo '   arrange_sh.sh:'
      >&2 cat -n arrange_sh.sh
    fi

.POSIX-test-matrix:
  extends: [".POSIX-test"]
  parallel:
    matrix:
    - SHELL_UNDER_TEST:
      - bash
      - busybox
      - dash
      #- loksh
      #- oksh
      - mksh
      #- nsh
      #- mrsh
      #- yash
      #- zsh
      BASE_DOCKER_IMAGE: 'alpine:edge'
    - SHELL_UNDER_TEST:
      - bash
      - busybox
      - dash
      - ksh93
      - mksh
      - posh
      #- yash
      - zsh
      BASE_DOCKER_IMAGE: 'debian:testing-slim'
  before_script:
  - !reference [.POSIX-test, before_script]
  - exit_code=0
  - sh arrange_sh.sh || exit_code=$?
  - if [ $exit_code -eq 66 ]; then exit 0; fi
  - if [ $exit_code -ne 0 ]; then exit $exit_code; fi
  after_script:
  - !reference [.POSIX-test, after_script]

.POSIX-combined-test:
  extends: [".POSIX-test"]
  before_script:
  - !reference [.POSIX-test, before_script]
  - |
    cat <<'EOScript' >for_all_shells.sh
    echo "Shells are: $SHELLS_UNDER_TEST"
    set -e
    fail=0
    for line in $SHELLS_UNDER_TEST; do
        [ "${line#'#'}" = "$line" ] || continue
        shell=$line
        echo "Testing $shell..."
        SHELL_UNDER_TEST=$shell sh arrange_sh.sh || continue
        for test_script in "$@"; do
            descr="$test_script in $shell"
            if sh "$test_script"; then
                echo ok - $descr
            else
                echo not ok - $descr
                >&2 echo "   $test_script:"
                >&2 cat -n "$test_script"
                fail=$(( fail + 1 ))
            fi
        done
    done
    exit "$(( fail != 0 ))"
    EOScript
  after_script:
  - |
    if [ $CI_JOB_STATUS != 'success' ]; then
      >&2 echo '   for_all_shells.sh:'
      >&2 cat -n for_all_shells.sh
    fi
  - !reference [.POSIX-test, after_script]
